/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"

// Recherche dichotomique dans un tableau trié

// on recherche v dans a[lo..hi[
// on renvoie une position de v et -1 s'il n'apparaît pas
int binary_search(int v, int a[], int n) {
  int lo = 0, hi = n;
  while (lo < hi) {
    // invariant : si v est dans a, alors v est dans a[lo..hi[
    int mid = lo + (hi - lo) / 2;
    if (a[mid] == v) return mid;
    if (v < a[mid]) { hi = mid; } else { lo = mid + 1; }
  }
  return -1;
}

int binary_fail(int v, int a[], int n) {
  int lo = 0, hi = n;
  while (lo < hi) {
    // invariant : si v est dans a, alors v est dans a[lo..hi[
    int mid = lo + (hi - lo) / 2;
    if (a[mid] == v) return mid;
    if (v < a[mid]) { hi = mid; } else { lo = mid; }
  }
  return -1;
}

int sequential_search(int v, int a[], int n) {
  for (int i = 0; i < n; i++) {
    if (a[i] == v) return i;
  }
  return -1;
}

int binary_search_last(int v, int a[], int n) {
  int lo = 0, hi = n;
  while (lo + 1 < hi) {
    int mid = lo + (hi - lo) / 2;
    if (v < a[mid]) { hi = mid; } else { lo = mid; }
  }
  if (a[lo] == v) { return lo; }
  else { return -1; }
}
